# -*- coding: utf-8 -*-
"""
Created on Tue Apr 26 12:36:57 2016

@author: kswider
"""
   
# Zmienne logiczne (boolowskie) funkcjonują w Pythonie podobnie jak w innych
# językach, poza tym, że są pisane z dużej litery
   
jeden_to_mniej_niz_dwa = 1 < 2       # podstawia True
prawda_to_falsz = True == False      # podstawia False
    
# Aanalogicznie do null w innych językach, w Pythonie symbol None oznacza
# nieistniejącą wartość
    
x = None
print x == None         # wyświetla True, ale nie jest w "stylu" Pythona
print x is None         # wyświetla True i jest w "stylu" Pythona

# Python pozwala na użycie dowolnej wartości tam, gdzie jest spodziewana
# wartość logiczna. Oznacza to w szczegolnosci, ze "nieprawdą" są następujące 
# konstrukcje:
   False
   None
   []       # lista pusta
   {}       # pusty słownik
   ""
   set()
   0
   0.0
   
# Ogolnie biorąc, wszelkie inne konstrukcje są traktowane jako True. Dzięki 
# temu można łatwo użyć warunku if do wykrycia pustej listy, pustych łańcuchow,
# pustych słownikow itp. Czasami powoduje to niepotrzebne komplikowanie:
   
s = pewna _funkcja_ktora_zwraca_lancuch()
if s:
    pierwszy_znak = s[0]
else:
    pierwszy_znak = ""
    
# To samo można uzyskać prościej następująco:

pierwszy_znak = s and s[0]

# ponieważ operacja and zwraca drugi operand o ile pierwszy jest "prawdą" lub
# zwraca pierwszy operand w przeciwnym wypadku. Analogicznie można wykorzystać
# działanie operacji or. Na przykład w przypadku, gdy x jest liczbą lub None to

bezpieczne_x = x or 0

# podstawia na pewno liczbę.

# Python udostępnia funkcję all, ktra wykonuje się dla listy i zwraca True
# o ile każdy element listy jest "prawdziwy". Z kolei funkcja any zwraca
# True w przypadku jeśli przynajmniej jeden element listy jest prawdziwy.

all([True, 1, { 3 }])       # True
all([True, 1, {}])          # False, {} nie jest prawdziwe
any([True, 1, {}])          # True, True is prawdziwe
all([])              # True, lista nie zawiera elementow "nieprawdziwych"
any([])              # False,lista nie zawiera elementow "prawdziwych"



