# -*- coding: utf-8 -*-
"""
Created on Tue Apr 26 12:36:57 2016

@author: kswider
"""
   
# Lista jest być może najbardziej fundamentalną strukturą w Pythonie
# Listą jest po prostu uporządkowana kolekcja. Jest ona zbliżona do
# stosowanych w innych językach tablic, z pewnymi dodatkowymi możliwościami.

lista_calk = [1,2,3]
lista_niejedn = ["słowo", 0.1, True]
lista_list = [lista_calk, lista_niejedn, []]

dlugosc_listy = len(lista_calk)     # wynosi 3
suma_listy = sum(lista_calk)        # wynosi 6

# Można pobrać lub nadać wartość n-tego elementu listy używając nawiasow
# kwadratowych:

x = range(10)    # utworzenie listy [0, 1, ..., 9]
zero = x[0]      # wynosi 0, listy są indeksowane od 0.
one = x[1]       # wynosi 1
nine = x[-1]     # wynosi 9, 'Pythonowe' odwołanie do ostatniego elementu
eight = x[-2]    # wynosi 8, 'Pythonowe' odwołanie do przedostatniego elementu
x[0] = -1        # teraz lista x ma postać [-1, 1, 2, 3, ..., 9]

# Nawiasow kwadratowych mozna także używać do "krojenia" list.

pierwsze_trzy = x[:3]                       # [-1, 1, 2]
od_trzy_do_konca = x[3:]                    # [3, 4, ..., 9]
od_jeden_do_cztery = x[1:5]                 # [1, 2, 3, 4]
ostatnie_trzy = x[-3:]                      # [7, 8, 9]
bez_pierwszego_i_ostatniego = x[1:-1]       # [1, 2, ..., 8]
kopia_x = x[:]                              # [-1, 1, 2, ..., 9]

# Python ma operację sprawdzania przynależności do listy

1 in [1, 2, 3] # True
0 in [1, 2, 3] # False

# Elementy listy są sprawdzane pojedynczo, przez co zaleca się ograniczyć
# stosowanie operatora in do mniejszych list lub sytuacji, gdzie czas nie 
# odgrywa decydującej roli.
#
# Listy można łatwo ze sobą 'sklejać':

x = [1, 2, 3]
x.extend([4, 5, 6]) # x jest teraz [1,2,3,4,5,6]
#
# Tam, gdzie modyfikacja listy x nie jest pożądana, stosujemy sumowanie list:

x = [1, 2, 3]
y = x + [4, 5, 6]  # y to [1, 2, 3, 4, 5, 6]; x pozostaje niezmieniona

# Dosyć często zachodzi potrzeba dołączania do listy pojedynczego elementu:

x = [1, 2, 3]
x.append(0) # x jest teraz [1, 2, 3, 0]
y = x[-1] # wynosi 0
z = len(x) # wynosi 4

# Dla list o znanej liczbie elementow czasami przydaje się ich rozpakowanie:

x, y = [1, 2] # teraz x to 1, a y to 2

# Zmienną, ktorej przypada wartość nieistotna dla dalszych działań (odrzucana)
# powszechnie oznacza się znakiem podkreślenia '_':

_, y = [1, 2] # teraz y == 2, pierwszy element nas już nie interesuje.






