# -*- coding: utf-8 -*-
"""
Created on Tue Apr 26 12:36:57 2016

@author: kswider
"""
   
# Krotki są strukturami, ktre wykazują znaczące podobieństwo do list.
# Większość operacji możliwych do wykonania na listach i nie modyfikujących
# ich struktury jest możliwa także dla krotek. W odrożnieniu od list, gdzie
# używane są nawiasy kwadratowe, krotkę definiuje się przy użyciu nawiasow 
# okrągłych (lub bez żadnych nawiasow).
   

moja_lista = [1, 2]
moja_krotka = (1, 2)
inna_krotka = 3, 4
moja_lista[1] = 3       # moja_lista teraz ma postać [1, 3]
try:
    moja_krotka[1] = 3
except TypeError:
    print "nie można modyfikowac krotki"

# Krotki przydają się przy zwracaniu wielu wartości przez funkcje

def suma_i_iloczyn(x, y):
    return (x + y),(x * y)

sp = suma_i_iloczyn(2, 3)        # zwraca (5, 6)
s, p = suma_i_iloczyn(5, 10)     # s to 15, p to 50

# Krotki (i listy) mogą być także użyte do grupowego nadawania wartości:

x, y = 1, 2     # teraz x jest rowne 1, a y jest rowne 2
x, y = y, x     # zmienne zamieniają się wartościami; teraz x to 2, y to 1
